Home | History | Annotate | Line # | Download | only in dist
makedefs revision 1.1.1.11
      1       1.1  tron #!/bin/sh
      2       1.1  tron 
      3       1.1  tron #++
      4       1.1  tron # NAME
      5       1.1  tron #	makedefs 1
      6       1.1  tron # SUMMARY
      7       1.1  tron #	makefile configuration utility
      8       1.1  tron # SYNOPSIS
      9       1.1  tron #	\fBmake makefiles \fIname=value...\fR
     10       1.1  tron # DESCRIPTION
     11       1.1  tron #	The \fBmakedefs\fR command identifies the compilation
     12       1.1  tron #	environment, and emits macro definitions on the standard output
     13       1.1  tron #	stream that can be prepended to template Makefiles.
     14       1.1  tron #
     15       1.1  tron #	Default settings can be overruled by specifying them as
     16       1.1  tron #	environment variables. Use quotes if variables contain
     17       1.1  tron #	whitespace or shell meta characters.
     18       1.1  tron # .IP \fBAUXLIBS=\fIobject_library...\fR
     19       1.1  tron #	Specifies one or more non-default object libraries.
     20       1.1  tron # .IP \fBCC=\fIcompiler_command\fR
     21       1.1  tron #	Specifies a non-default compiler. On many systems, the default
     22       1.1  tron #	is \fBgcc\fR.
     23       1.1  tron # .IP \fBCCARGS=\fIcompiler_arguments\fR
     24       1.1  tron #	Specifies non-default compiler arguments, for example, a non-default
     25       1.1  tron #	\fIinclude\fR directory.
     26       1.1  tron #	The following directives are special:
     27       1.1  tron # .RS
     28   1.1.1.8  tron # .IP \fB-DNO_DB\fR
     29   1.1.1.8  tron #	Do not build with Berkeley DB support.
     30       1.1  tron # .IP \fB-DNO_DEVPOLL\fR
     31       1.1  tron #	Do not build with Solaris /dev/poll support.
     32       1.1  tron #	By default, /dev/poll support is compiled in on platforms that
     33       1.1  tron #	are known to support it.
     34       1.1  tron # .IP \fB-DNO_EPOLL\fR
     35       1.1  tron #	Do not build with Linux EPOLL support.
     36       1.1  tron #	By default, EPOLL support is compiled in on platforms that
     37       1.1  tron #	are known to support it.
     38       1.1  tron # .IP \fB-DNO_IPV6\fR
     39       1.1  tron #	Do not build with IPv6 support.
     40       1.1  tron #	By default, IPv6 support is compiled in on platforms that
     41       1.1  tron #	are known to have IPv6 support.
     42       1.1  tron #
     43       1.1  tron #	Note: this directive is for debugging and testing only. It
     44       1.1  tron #	is not guaranteed to work on all platforms.
     45       1.1  tron # .IP \fB-DNO_KQUEUE\fR
     46       1.1  tron #	Do not build with FreeBSD/NetBSD/OpenBSD/MacOSX KQUEUE support.
     47       1.1  tron #	By default, KQUEUE support is compiled in on platforms that
     48       1.1  tron #	are known to support it.
     49   1.1.1.8  tron # .IP \fB-DNO_NIS\fR
     50   1.1.1.8  tron #	Do not build with NIS or NISPLUS support. Support for NIS
     51  1.1.1.10  tron #	is unavailable on some recent Linux distributions.
     52  1.1.1.10  tron # .IP \fB-DNO_NISPLUS\fR
     53  1.1.1.10  tron #	Do not build with NISPLUS support. Support for NISPLUS
     54  1.1.1.10  tron #	is unavailable on some recent Solaris distributions.
     55       1.1  tron # .IP \fB-DNO_PCRE\fR
     56       1.1  tron #	Do not build with PCRE support.
     57       1.1  tron #	By default, PCRE support is compiled in when the \fBpcre-config\fR
     58       1.1  tron #	utility is installed.
     59   1.1.1.8  tron # .IP \fB-DNO_POSIX_GETPW_R\fR
     60   1.1.1.8  tron #	Disable support for POSIX getpwnam_r/getpwuid_r.
     61       1.1  tron # .IP \fB-DNO_SIGSETJMP\fR
     62       1.1  tron #	Use setjmp()/longjmp() instead of sigsetjmp()/siglongjmp().
     63       1.1  tron #	By default, Postfix uses sigsetjmp()/siglongjmp() when they
     64       1.1  tron #	appear to work.
     65       1.1  tron # .RE
     66       1.1  tron # .IP \fBDEBUG=\fIdebug_level\fR
     67       1.1  tron #	Specifies a non-default debugging level. The default is \fB-g\fR.
     68       1.1  tron #	Specify \fBDEBUG=\fR to turn off debugging.
     69       1.1  tron # .IP \fBOPT=\fIoptimization_level\fR
     70       1.1  tron #	Specifies a non-default optimization level. The default is \fB-O\fR.
     71       1.1  tron #	Specify \fBOPT=\fR to turn off optimization.
     72       1.1  tron # .IP \fBWARN=\fIwarning_flags\fR
     73       1.1  tron #	Specifies non-default gcc compiler warning options for use when
     74       1.1  tron #	"make" is invoked in a source subdirectory only.
     75       1.1  tron # LICENSE
     76       1.1  tron # .ad
     77       1.1  tron # .fi
     78       1.1  tron #	The Secure Mailer license must be distributed with this software.
     79       1.1  tron # AUTHOR(S)
     80       1.1  tron #	Wietse Venema
     81       1.1  tron #	IBM T.J. Watson Research
     82       1.1  tron #	P.O. Box 704
     83       1.1  tron #	Yorktown Heights, NY 10598, USA
     84       1.1  tron #--
     85       1.1  tron 
     86       1.1  tron # Emit system-dependent Makefile macro definitions to standard output.
     87       1.1  tron 
     88       1.1  tron # Defaults for most sane systems
     89       1.1  tron 
     90       1.1  tron RANLIB=ranlib
     91       1.1  tron SYSLIBS=
     92       1.1  tron AR=ar
     93       1.1  tron ARFL=rv
     94       1.1  tron 
     95       1.1  tron # Ugly function to make our error message more visible among the
     96       1.1  tron # garbage that is output by some versions of make(1).
     97       1.1  tron 
     98       1.1  tron # By now all shells must have functions.
     99       1.1  tron 
    100       1.1  tron error() {
    101       1.1  tron    # Alas, tput(1) is not portable so we can't use visual effects.
    102       1.1  tron    echo "ATTENTION:" 1>&2;
    103       1.1  tron    echo "ATTENTION:" $* 1>&2;
    104       1.1  tron    echo "ATTENTION:" 1>&2;
    105       1.1  tron    exit 1
    106       1.1  tron }
    107       1.1  tron 
    108       1.1  tron case $# in
    109       1.1  tron  # Officially supported usage.
    110       1.1  tron  0) SYSTEM=`(uname -s) 2>/dev/null`
    111       1.1  tron     RELEASE=`(uname -r) 2>/dev/null`
    112       1.1  tron     VERSION=`(uname -v) 2>/dev/null`
    113       1.1  tron     case "$VERSION" in
    114       1.1  tron      dcosx*) SYSTEM=$VERSION;;
    115       1.1  tron     esac;;
    116       1.1  tron  # Unsupported debug-only mode. Not suitable for cross-platform tests.
    117       1.1  tron  2) SYSTEM="$1"; RELEASE="$2";;
    118       1.1  tron  *) echo usage: $0 [system release] 1>&2; exit 1;;
    119       1.1  tron esac
    120       1.1  tron 
    121       1.1  tron case "$SYSTEM.$RELEASE" in
    122       1.1  tron    SCO_SV.3.2)	SYSTYPE=SCO5
    123       1.1  tron 		# Use the native compiler by default
    124       1.1  tron 		: ${CC="/usr/bin/cc -b elf"}
    125       1.1  tron 		CCARGS="$CCARGS -DPIPES_CANT_FIONREAD $CCARGS"
    126       1.1  tron 		SYSLIBS="-lsocket -ldbm"
    127       1.1  tron 		RANLIB=echo
    128       1.1  tron 		;;
    129       1.1  tron   UnixWare.5*)	SYSTYPE=UW7
    130       1.1  tron 		# Use the native compiler by default
    131       1.1  tron 		: ${CC=/usr/bin/cc}
    132       1.1  tron 		RANLIB=echo
    133       1.1  tron 		SYSLIBS="-lresolv -lsocket -lnsl"
    134       1.1  tron 		;;
    135       1.1  tron   UNIX_SV.4.2*)	case "`uname -v`" in
    136       1.1  tron 	      2.1*) SYSTYPE=UW21
    137       1.1  tron 		    # Use the native compiler by default
    138       1.1  tron 		    : ${CC=/usr/bin/cc}
    139       1.1  tron 		    RANLIB=echo
    140       1.1  tron 		    SYSLIBS="-lresolv -lsocket -lnsl -lc -L/usr/ucblib -lucb"
    141       1.1  tron 		    ;;
    142       1.1  tron 	      *) error "Seems to be UnixWare`uname -v`. Untested.";;
    143       1.1  tron 		esac
    144       1.1  tron 		;;
    145       1.1  tron   FreeBSD.2*)	SYSTYPE=FREEBSD2
    146       1.1  tron 		;;
    147       1.1  tron   FreeBSD.3*)	SYSTYPE=FREEBSD3
    148       1.1  tron 		;;
    149       1.1  tron   FreeBSD.4*)	SYSTYPE=FREEBSD4
    150       1.1  tron 		;;
    151       1.1  tron   FreeBSD.5*)	SYSTYPE=FREEBSD5
    152       1.1  tron 		;;
    153       1.1  tron   FreeBSD.6*)	SYSTYPE=FREEBSD6
    154       1.1  tron 		;;
    155       1.1  tron   FreeBSD.7*)	SYSTYPE=FREEBSD7
    156       1.1  tron 		;;
    157   1.1.1.2  tron   FreeBSD.8*)	SYSTYPE=FREEBSD8
    158   1.1.1.2  tron 		;;
    159   1.1.1.7  tron   FreeBSD.9*)	SYSTYPE=FREEBSD9
    160   1.1.1.7  tron 		;;
    161  1.1.1.10  tron  DragonFly.*)	SYSTYPE=DRAGONFLY
    162  1.1.1.10  tron 		;;
    163       1.1  tron   OpenBSD.2*)	SYSTYPE=OPENBSD2
    164       1.1  tron 		;;
    165       1.1  tron   OpenBSD.3*)	SYSTYPE=OPENBSD3
    166       1.1  tron 		;;
    167       1.1  tron   OpenBSD.4*)	SYSTYPE=OPENBSD4
    168       1.1  tron 		;;
    169   1.1.1.6  tron   OpenBSD.5*)	SYSTYPE=OPENBSD5
    170   1.1.1.6  tron 		;;
    171       1.1  tron   ekkoBSD.1*)	SYSTYPE=EKKOBSD1
    172       1.1  tron 		;;
    173       1.1  tron    NetBSD.1*)	SYSTYPE=NETBSD1
    174       1.1  tron 		;;
    175       1.1  tron    NetBSD.2*)	SYSTYPE=NETBSD2
    176       1.1  tron 		;;
    177       1.1  tron    NetBSD.3*)	SYSTYPE=NETBSD3
    178       1.1  tron 		;;
    179       1.1  tron    NetBSD.4*)	SYSTYPE=NETBSD4
    180       1.1  tron 		;;
    181  1.1.1.10  tron    NetBSD.5*)	SYSTYPE=NETBSD5
    182  1.1.1.10  tron 		;;
    183  1.1.1.10  tron    NetBSD.6*)	SYSTYPE=NETBSD6
    184  1.1.1.10  tron 		;;
    185       1.1  tron    BSD/OS.2*)	SYSTYPE=BSDI2
    186       1.1  tron 		;;
    187       1.1  tron    BSD/OS.3*)	SYSTYPE=BSDI3
    188       1.1  tron 		;;
    189       1.1  tron    BSD/OS.4*)	SYSTYPE=BSDI4
    190       1.1  tron 		;;
    191       1.1  tron  OSF1.V[3-5].*)	SYSTYPE=OSF1
    192       1.1  tron 		# Use the native compiler by default
    193       1.1  tron 		: ${CC=cc}
    194       1.1  tron 		: ${DEBUG="-g3"}
    195       1.1  tron 		case $RELEASE in
    196       1.1  tron 		V[0-4].*) CCARGS="$CCARGS -DNO_IPV6";;
    197       1.1  tron 		esac
    198       1.1  tron 		;;
    199       1.1  tron     SunOS.4*)	SYSTYPE=SUNOS4
    200       1.1  tron 		SYSLIBS=-lresolv
    201       1.1  tron 		;;
    202       1.1  tron     SunOS.5*)	SYSTYPE=SUNOS5
    203       1.1  tron 		RANLIB=echo
    204  1.1.1.10  tron 		SYSLIBS="-lresolv -lsocket -lnsl -ldl"
    205       1.1  tron 		# Stock awk breaks with >10 files.
    206       1.1  tron 		test -x /usr/xpg4/bin/awk && AWK=/usr/xpg4/bin/awk
    207   1.1.1.8  tron 		# Solaris 2.5 added usleep(), POSIX regexp, POSIX getpwnam/uid_r
    208       1.1  tron 		case $RELEASE in
    209   1.1.1.8  tron 		    5.[0-4]) CCARGS="$CCARGS -DMISSING_USLEEP -DNO_POSIX_REGEXP -DNO_POSIX_GETPW_R";;
    210       1.1  tron 		esac
    211       1.1  tron 		# Solaris 8 added IPv6 and /dev/poll
    212       1.1  tron 		case $RELEASE in
    213       1.1  tron 		    5.[0-7]|5.[0-7].*) CCARGS="$CCARGS -DNO_IPV6 -DNO_DEVPOLL";;
    214       1.1  tron 		esac
    215       1.1  tron 		# Solaris 9 added closefrom(), futimesat() and /dev/*random
    216   1.1.1.9  tron 		# and appears to have solid UNIX-domain sockets.
    217       1.1  tron 		case $RELEASE in
    218   1.1.1.9  tron 		    5.[0-8]|5.[0-8].*) CCARGS="$CCARGS -DNO_CLOSEFROM -DNO_DEV_URANDOM -DNO_FUTIMESAT -DSTREAM_CONNECTIONS";;
    219       1.1  tron 		esac
    220  1.1.1.10  tron 		# Somewhere NISPLUS went away.
    221  1.1.1.10  tron 		case $RELEASE in
    222  1.1.1.10  tron 		    5.[0-9][0-9]*) CCARGS="$CCARGS -DNO_NISPLUS";;
    223  1.1.1.10  tron 		esac
    224       1.1  tron 		# Work around broken str*casecmp(). Do it all here instead
    225       1.1  tron 		# of having half the solution in the sys_defs.h file.
    226       1.1  tron 		CCARGS="$CCARGS -Dstrcasecmp=fix_strcasecmp \
    227       1.1  tron 		    -Dstrncasecmp=fix_strncasecmp"
    228       1.1  tron 		STRCASE="strcasecmp.o"
    229       1.1  tron 		# Avoid common types of braindamage
    230       1.1  tron 		case "$LD_LIBRARY_PATH" in
    231       1.1  tron 		?*) error "Don't set LD_LIBRARY_PATH";;
    232       1.1  tron 		esac
    233       1.1  tron 		case "${CC}" in
    234       1.1  tron 		*" "*) ;;
    235       1.1  tron 		*ucb*) error "Don't use /usr/ucb/cc or ucblib";;
    236       1.1  tron 		  cc*) case `which ${CC}` in
    237       1.1  tron 		*ucb*) error "Don't use /usr/ucb/cc or ucblib";;
    238       1.1  tron 		  esac;;
    239       1.1  tron 		esac
    240       1.1  tron 		;;
    241       1.1  tron    ULTRIX.4*)	SYSTYPE=ULTRIX4
    242       1.1  tron 		if [ -f /usr/local/lib/libdb.a ]; then
    243       1.1  tron 		    SYSLIBS="$SYSLIBS -ldb"
    244       1.1  tron 		    CCARGS="$CCARGS -DHAS_DB"
    245       1.1  tron 		    if [ -d /usr/local/include/db ]; then
    246       1.1  tron 			CCARGS="$CCARGS -I/usr/local/include/db"
    247       1.1  tron 		    fi
    248       1.1  tron 		fi
    249       1.1  tron 		for l in syslog resolv; do
    250       1.1  tron 		    if [ -f /usr/local/lib/lib$l.a ]; then
    251       1.1  tron 			SYSLIBS="$SYSLIBS -l$l"
    252       1.1  tron 		    fi
    253       1.1  tron 		done
    254       1.1  tron 		;;
    255       1.1  tron        AIX.*)	case "`uname -v`" in
    256   1.1.1.4  tron 		6)	SYSTYPE=AIX6
    257   1.1.1.4  tron 			case "$CC" in
    258   1.1.1.4  tron 			cc|*/cc|xlc|*/xlc) CCARGS="$CCARGS -w -blibpath:/usr/lib:/lib:/usr/local/lib";;
    259   1.1.1.4  tron 			esac
    260   1.1.1.4  tron 			CCARGS="$CCARGS -D_ALL_SOURCE -DHAS_POSIX_REGEXP"
    261   1.1.1.4  tron 			;;
    262       1.1  tron 		5)	SYSTYPE=AIX5
    263       1.1  tron 			case "$CC" in
    264       1.1  tron 			cc|*/cc|xlc|*/xlc) CCARGS="$CCARGS -w -blibpath:/usr/lib:/lib:/usr/local/lib";;
    265       1.1  tron 			esac
    266       1.1  tron 			CCARGS="$CCARGS -D_ALL_SOURCE -DHAS_POSIX_REGEXP"
    267       1.1  tron 			;;
    268       1.1  tron 		4)	SYSTYPE=AIX4
    269       1.1  tron 			# How embarrassing...
    270       1.1  tron 			case "$CC" in
    271       1.1  tron 			cc|*/cc|xlc|*/xlc) OPT=; CCARGS="$CCARGS -w -blibpath:/usr/lib:/lib:/usr/local/lib";;
    272       1.1  tron 			esac
    273       1.1  tron 			CCARGS="$CCARGS -D_ALL_SOURCE -DHAS_POSIX_REGEXP"
    274       1.1  tron 			;;
    275       1.1  tron 		3)	SYSTYPE=AIX3
    276       1.1  tron 			# How embarrassing...
    277       1.1  tron 			case "$CC" in
    278       1.1  tron 			cc|*/cc|xlc|*/xlc) OPT=; CCARGS="$CCARGS -w";;
    279       1.1  tron 			esac
    280       1.1  tron 			CCARGS="$CCARGS -D_ALL_SOURCE"
    281       1.1  tron 			;;
    282       1.1  tron 		*)	error "Unknown AIX version: `uname -v`.";;
    283       1.1  tron 		esac;;
    284       1.1  tron 		# Tested with RedHat 3.03 on 20020729.
    285       1.1  tron     Linux.1*)	SYSTYPE=LINUX1
    286   1.1.1.9  tron 		case "$CCARGS" in
    287   1.1.1.9  tron 		 *-DNO_DB*) ;;
    288  1.1.1.10  tron 		 *-DHAS_DB*) ;;
    289   1.1.1.9  tron 		 *) SYSLIBS="-ldb";;
    290   1.1.1.9  tron 		esac
    291       1.1  tron 		;;
    292       1.1  tron     Linux.2*)	SYSTYPE=LINUX2
    293   1.1.1.9  tron 		case "$CCARGS" in
    294   1.1.1.9  tron 		 *-DNO_DB*) ;;
    295  1.1.1.10  tron 		 *-DHAS_DB*) ;;
    296   1.1.1.9  tron 		 *) if [ -f /usr/include/db.h ]
    297   1.1.1.9  tron 		    then
    298   1.1.1.9  tron 			: we are all set
    299   1.1.1.9  tron 		    elif [ -f /usr/include/db/db.h ]
    300   1.1.1.9  tron 		    then
    301   1.1.1.9  tron 			CCARGS="$CCARGS -I/usr/include/db"
    302   1.1.1.9  tron 		    else
    303   1.1.1.9  tron 			# No, we're not going to try db1 db2 db3 etc.
    304   1.1.1.9  tron 			# On a properly installed system, Postfix builds
    305   1.1.1.9  tron 			# by including <db.h> and by linking with -ldb
    306   1.1.1.9  tron 			echo "No <db.h> include file found." 1>&2
    307   1.1.1.9  tron 			echo "Install the appropriate db*-devel package first." 1>&2
    308   1.1.1.9  tron 			exit 1
    309   1.1.1.9  tron 		    fi
    310   1.1.1.9  tron 		    SYSLIBS="-ldb"
    311   1.1.1.9  tron 		    ;;
    312   1.1.1.9  tron 		esac
    313       1.1  tron 		for name in nsl resolv $GDBM_LIBS
    314       1.1  tron 		do
    315       1.1  tron 		    for lib in /usr/lib64 /lib64 /usr/lib /lib
    316       1.1  tron 		    do
    317       1.1  tron 			test -e $lib/lib$name.a -o -e $lib/lib$name.so && {
    318       1.1  tron 			    SYSLIBS="$SYSLIBS -l$name"
    319       1.1  tron 			    break
    320       1.1  tron 			}
    321       1.1  tron 		    done
    322       1.1  tron 		done
    323       1.1  tron 		# Kernel 2.4 added IPv6
    324       1.1  tron 		case "$RELEASE" in
    325       1.1  tron 		2.[0-3].*) CCARGS="$CCARGS -DNO_IPV6";;
    326       1.1  tron 		esac
    327       1.1  tron 		# Kernel 2.6 added EPOLL
    328       1.1  tron 		case "$RELEASE" in
    329       1.1  tron 		2.[0-5].*) CCARGS="$CCARGS -DNO_EPOLL";;
    330       1.1  tron 		    # Workaround for retarded libc 
    331   1.1.1.3  tron 		    2.6.*)
    332   1.1.1.3  tron 		       if [ `expr "X$CCARGS" : "X.*-DNO_EPOLL"` -gt 0 ]
    333  1.1.1.10  tron 		       then
    334  1.1.1.10  tron 			   :
    335  1.1.1.10  tron 		       elif [ ! -e /usr/include/sys/epoll.h ]
    336  1.1.1.10  tron 		       then
    337  1.1.1.10  tron 			   echo CCARGS="$CCARGS -DNO_EPOLL"
    338  1.1.1.10  tron 		       else
    339   1.1.1.3  tron 			   trap 'rm -f makedefs.test makedefs.test.[co]' 1 2 3 15
    340       1.1  tron 			   cat >makedefs.test.c <<'EOF'
    341       1.1  tron #include <sys/types.h>
    342       1.1  tron #include <sys/epoll.h>
    343       1.1  tron #include <errno.h>
    344       1.1  tron #include <stdio.h>
    345       1.1  tron #include <stdlib.h>
    346       1.1  tron 
    347       1.1  tron int     main(int argc, char **argv)
    348       1.1  tron {
    349       1.1  tron     int     epoll_handle;
    350       1.1  tron 
    351       1.1  tron     if ((epoll_handle = epoll_create(1)) < 0) {
    352       1.1  tron 	perror("epoll_create");
    353       1.1  tron 	exit(1);
    354       1.1  tron     }
    355       1.1  tron     exit(0);
    356       1.1  tron }
    357       1.1  tron EOF
    358       1.1  tron 			   ${CC-gcc} -o makedefs.test makedefs.test.c || exit 1
    359       1.1  tron 			   ./makedefs.test 2>/dev/null ||
    360       1.1  tron 				CCARGS="$CCARGS -DNO_EPOLL"
    361   1.1.1.3  tron 			   rm -f makedefs.test makedefs.test.[co]
    362   1.1.1.3  tron 		       fi;;
    363       1.1  tron 		esac
    364       1.1  tron 		;;
    365   1.1.1.5  tron     Linux.3*)	SYSTYPE=LINUX3
    366   1.1.1.9  tron 		case "$CCARGS" in
    367   1.1.1.9  tron 		 *-DNO_DB*) ;;
    368  1.1.1.10  tron 		 *-DHAS_DB*) ;;
    369   1.1.1.9  tron 		 *) if [ -f /usr/include/db.h ]
    370   1.1.1.9  tron 		    then
    371   1.1.1.9  tron 			: we are all set
    372   1.1.1.9  tron 		    elif [ -f /usr/include/db/db.h ]
    373   1.1.1.9  tron 		    then
    374   1.1.1.9  tron 			CCARGS="$CCARGS -I/usr/include/db"
    375   1.1.1.9  tron 		    else
    376   1.1.1.9  tron 			# On a properly installed system, Postfix builds
    377   1.1.1.9  tron 			# by including <db.h> and by linking with -ldb
    378   1.1.1.9  tron 			echo "No <db.h> include file found." 1>&2
    379   1.1.1.9  tron 			echo "Install the appropriate db*-devel package first." 1>&2
    380   1.1.1.9  tron 			exit 1
    381   1.1.1.9  tron 		    fi
    382   1.1.1.9  tron 		    SYSLIBS="-ldb"
    383   1.1.1.9  tron 		    ;;
    384   1.1.1.9  tron 		esac
    385   1.1.1.5  tron 		for name in nsl resolv
    386   1.1.1.5  tron 		do
    387   1.1.1.9  tron 		    for lib in /usr/lib64 /lib64 /usr/lib /usr/lib/* /lib /lib/*
    388   1.1.1.5  tron 		    do
    389   1.1.1.5  tron 			test -e $lib/lib$name.a -o -e $lib/lib$name.so && {
    390   1.1.1.5  tron 			    SYSLIBS="$SYSLIBS -l$name"
    391   1.1.1.5  tron 			    break
    392   1.1.1.5  tron 			}
    393   1.1.1.5  tron 		    done
    394   1.1.1.5  tron 		done
    395   1.1.1.5  tron 		;;
    396       1.1  tron      GNU.0*|GNU/kFreeBSD.[567]*)
    397  1.1.1.10  tron 		SYSTYPE=GNU0
    398   1.1.1.9  tron 		case "$CCARGS" in
    399   1.1.1.9  tron 		 *-DNO_DB*) ;;
    400   1.1.1.9  tron 		 *) if [ -f /usr/include/db.h ]
    401   1.1.1.9  tron 		    then
    402   1.1.1.9  tron 			: we are all set
    403   1.1.1.9  tron 		    elif [ -f /usr/include/db/db.h ]
    404   1.1.1.9  tron 		    then
    405   1.1.1.9  tron 			CCARGS="$CCARGS -I/usr/include/db"
    406   1.1.1.9  tron 		    else
    407   1.1.1.9  tron 			# On a properly installed system, Postfix builds
    408   1.1.1.9  tron 			# by including <db.h> and by linking with -ldb
    409   1.1.1.9  tron 			echo "No <db.h> include file found." 1>&2
    410   1.1.1.9  tron 			echo "Install the appropriate db*-devel package first." 1>&2
    411   1.1.1.9  tron 			exit 1
    412   1.1.1.9  tron 		    fi
    413   1.1.1.9  tron 		    SYSLIBS="-ldb"
    414   1.1.1.9  tron 		    ;;
    415   1.1.1.9  tron 		esac
    416       1.1  tron 		for name in nsl resolv
    417       1.1  tron 		do
    418       1.1  tron 		    for lib in /usr/lib64 /lib64 /usr/lib /lib
    419       1.1  tron 		    do
    420       1.1  tron 			test -e $lib/lib$name.a -o -e $lib/lib$name.so && {
    421       1.1  tron 			    SYSLIBS="$SYSLIBS -l$name"
    422       1.1  tron 			    break
    423       1.1  tron 			}
    424       1.1  tron 		    done
    425       1.1  tron 		done
    426       1.1  tron 		case "`uname -s`" in
    427       1.1  tron 		GNU)
    428       1.1  tron 			# currently no IPv6 support on Hurd
    429       1.1  tron 			CCARGS="$CCARGS -DNO_IPV6"
    430       1.1  tron 			;;
    431       1.1  tron 		esac
    432       1.1  tron 		;;
    433       1.1  tron      IRIX*.5.*)	SYSTYPE=IRIX5
    434       1.1  tron 		# Use the native compiler by default
    435       1.1  tron 		: ${CC=cc} ${DEBUG="-g3"}
    436       1.1  tron 		RANLIB=echo
    437       1.1  tron 		;;
    438       1.1  tron      IRIX*.6.*)	SYSTYPE=IRIX6
    439       1.1  tron 		# Use the native compiler by default, and allow nested comments.
    440       1.1  tron 		: ${CC="cc -woff 1009,1116,1412"}
    441       1.1  tron 		RANLIB=echo
    442       1.1  tron 		;;
    443       1.1  tron HP-UX.A.09.*)	SYSTYPE=HPUX9
    444       1.1  tron 		SYSLIBS=-ldbm
    445       1.1  tron 		CCARGS="$CCARGS -DMISSING_USLEEP"
    446       1.1  tron 		if [ -f /usr/lib/libdb.a ]; then
    447       1.1  tron 		    CCARGS="$CCARGS -DHAS_DB"
    448       1.1  tron 		    SYSLIBS="$SYSLIBS -ldb"
    449       1.1  tron 		fi
    450       1.1  tron 		;;
    451       1.1  tron HP-UX.B.10.*)	SYSTYPE=HPUX10
    452       1.1  tron 		CCARGS="$CCARGS `nm /usr/lib/libc.a 2>/dev/null |
    453       1.1  tron 		    (grep usleep >/dev/null || echo '-DMISSING_USLEEP')`"
    454       1.1  tron 		if [ -f /usr/lib/libdb.a ]; then
    455       1.1  tron 		    CCARGS="$CCARGS -DHAS_DB"
    456       1.1  tron 		    SYSLIBS=-ldb
    457       1.1  tron 		fi
    458       1.1  tron 		;;
    459       1.1  tron HP-UX.B.11.*)	SYSTYPE=HPUX11
    460       1.1  tron 		SYSLIBS=-lnsl
    461       1.1  tron 		if [ -f /usr/lib/libdb.a ]; then
    462       1.1  tron 		    CCARGS="$CCARGS -DHAS_DB"
    463       1.1  tron 		    SYSLIBS="$SYSLIBS -ldb"
    464       1.1  tron 		fi
    465       1.1  tron 		;;
    466       1.1  tron ReliantUNIX-?.5.43) SYSTYPE=ReliantUnix543
    467       1.1  tron 		RANLIB=echo
    468       1.1  tron 		SYSLIBS="-lresolv -lsocket -lnsl"
    469       1.1  tron 		;;
    470       1.1  tron     Darwin.*)   SYSTYPE=MACOSX
    471       1.1  tron 		# Use the native compiler by default
    472       1.1  tron 		: ${CC=cc}
    473   1.1.1.9  tron 		CCARGS="$CCARGS \$(WARN)"
    474       1.1  tron 		# Darwin > 1.3 uses awk and flat_namespace
    475       1.1  tron 		case $RELEASE in
    476       1.1  tron 		 1.[0-3]) AWK=gawk;;
    477       1.1  tron 		       *) AWK=awk
    478  1.1.1.10  tron 			  SYSLIBS="$SYSLIBS -flat_namespace";;
    479       1.1  tron 		esac
    480       1.1  tron 		# Darwin 7 adds IPv6 support, BIND_8_COMPAT, NO_NETINFO
    481       1.1  tron 		case $RELEASE in
    482       1.1  tron 		 [1-6].*) CCARGS="$CCARGS -DNO_IPV6";;
    483       1.1  tron 		       *) CCARGS="$CCARGS -DBIND_8_COMPAT -DNO_NETINFO";;
    484       1.1  tron 		esac
    485   1.1.1.8  tron 		# Darwin 9.0 (MacOS X 10.5) adds POSIX getpwnam_r/getpwuid_r
    486   1.1.1.8  tron 		case $RELEASE in
    487   1.1.1.8  tron 		 [1-8].*) CCARGS="$CCARGS -DNO_POSIX_GETPW_R";;
    488   1.1.1.8  tron 		esac
    489   1.1.1.3  tron 		# Darwin 10.3.0 no longer has <nameser8_compat.h>.
    490   1.1.1.3  tron 		case $RELEASE in
    491   1.1.1.3  tron 		     ?.*) CCARGS="$CCARGS -DRESOLVE_H_NEEDS_NAMESER8_COMPAT_H";;
    492   1.1.1.3  tron 		       *) CCARGS="$CCARGS -DRESOLVE_H_NEEDS_ARPA_NAMESER_COMPAT_H";;
    493   1.1.1.3  tron 		esac
    494  1.1.1.11  tron 		# Darwin 11.x (MacOS X 10.7.x), maybe earlier, needs libresolv.
    495  1.1.1.10  tron 		case $RELEASE in
    496  1.1.1.11  tron 		?.*|10.*) ;;
    497  1.1.1.10  tron 		       *) SYSLIBS="$SYSLIBS -lresolv";;
    498  1.1.1.10  tron 		esac
    499  1.1.1.10  tron 		# kqueue and/or poll are broken in MacOS X 10.5 (Darwin 9).
    500  1.1.1.10  tron 		# kqueue works in Mac OS X 10.8 (Darwin 12).
    501  1.1.1.10  tron 		case $RELEASE in
    502  1.1.1.10  tron 	    ?.*|1[0-1].*) CCARGS="$CCARGS -DNO_KQUEUE";;
    503  1.1.1.10  tron 		esac
    504       1.1  tron 		;;
    505       1.1  tron     dcosx.1*)	SYSTYPE=DCOSX1
    506       1.1  tron 		RANLIB=echo
    507       1.1  tron 		SYSLIBS="-lresolv -lsocket -lnsl -lc -lrpcsvc -L/usr/ucblib -lucb"
    508       1.1  tron 		;;
    509       1.1  tron 
    510       1.1  tron 	 ".")	if [ -d /NextApps ]; then
    511       1.1  tron 		    SYSTYPE=`hostinfo | sed -n \
    512       1.1  tron 			's/^.*NeXT Mach 3.*$/NEXTSTEP3/;/NEXTSTEP3/{p;q;}'`
    513       1.1  tron 		    if [ "$SYSTYPE" = "" ]; then
    514       1.1  tron 			SYSTYPE=`hostinfo | sed -n \
    515       1.1  tron 			    's/^.*NeXT Mach 4.*$/OPENSTEP4/;/OPENSTEP4/{p;q;}'`
    516       1.1  tron 		    fi
    517       1.1  tron 		    : ${CC=cc}
    518       1.1  tron 		    RANLIB="sleep 5; ranlib"
    519       1.1  tron 		else
    520       1.1  tron 		    error "Unable to determine your system type."
    521       1.1  tron 		fi
    522       1.1  tron 		;;
    523       1.1  tron 	   *)	error "Unknown system type: $SYSTEM $RELEASE";;
    524       1.1  tron esac
    525       1.1  tron 
    526       1.1  tron #
    527       1.1  tron # sigsetjmp()/siglongjmp() can be "better" than setjmp()/longjmp()
    528       1.1  tron # if used wisely (that is: almost never, just like signals).
    529       1.1  tron # Unfortunately some implementations have been buggy in the past.
    530       1.1  tron #
    531       1.1  tron case "$CCARGS" in
    532       1.1  tron  *-DNO_SIGSETJMP*) ;;
    533  1.1.1.10  tron 		*) trap 'rm -f makedefs.test makedefs.test.[co]' 1 2 3 15
    534       1.1  tron 		   cat >makedefs.test.c <<'EOF'
    535       1.1  tron #include <setjmp.h>
    536       1.1  tron #include <stdlib.h>
    537       1.1  tron #include <stdio.h>
    538       1.1  tron 
    539       1.1  tron static int count = 0;
    540       1.1  tron 
    541       1.1  tron int     main(int argc, char **argv)
    542       1.1  tron {
    543       1.1  tron     sigjmp_buf env;
    544       1.1  tron     int     retval;
    545       1.1  tron 
    546       1.1  tron     switch (retval = sigsetjmp(env, 1)) {
    547       1.1  tron     case 0:
    548       1.1  tron 	siglongjmp(env, 12345);
    549       1.1  tron     case 12345:
    550       1.1  tron 	break;
    551       1.1  tron     default:
    552       1.1  tron 	fprintf(stderr, "Error: siglongjmp ignores second argument\n");
    553       1.1  tron 	exit(1);
    554       1.1  tron     }
    555       1.1  tron 
    556       1.1  tron     switch (retval = sigsetjmp(env, 1)) {
    557       1.1  tron     case 0:
    558       1.1  tron 	if (count++ > 0) {
    559       1.1  tron 	    fprintf(stderr, "Error: not overriding siglongjmp(env, 0)\n");
    560       1.1  tron 	    exit(1);
    561       1.1  tron 	}
    562       1.1  tron 	siglongjmp(env, 0);
    563       1.1  tron     case 1:
    564       1.1  tron 	break;
    565       1.1  tron     default:
    566       1.1  tron 	fprintf(stderr, "Error: overriding siglongjmp(env, 0) with %d\n",
    567       1.1  tron 		retval);
    568       1.1  tron 	exit(1);
    569       1.1  tron     }
    570       1.1  tron     exit(0);
    571       1.1  tron }
    572       1.1  tron EOF
    573       1.1  tron 		   ${CC-gcc} -o makedefs.test makedefs.test.c || exit 1
    574       1.1  tron 		   ./makedefs.test 2>/dev/null ||
    575       1.1  tron 			CCARGS="$CCARGS -DNO_SIGSETJMP"
    576       1.1  tron 		   rm -f makedefs.test makedefs.test.[co]
    577       1.1  tron esac
    578       1.1  tron 
    579       1.1  tron #
    580       1.1  tron # OpenSSL has no configuration query utility, but we don't try to
    581       1.1  tron # guess. We assume includes in /usr/include/openssl and libraries in
    582       1.1  tron # /usr/lib, or in their /usr/local equivalents. If the OpenSSL files
    583       1.1  tron # are in a non-standard place, their locations need to be specified.
    584       1.1  tron #
    585       1.1  tron #case "$CCARGS" in
    586       1.1  tron # *-DUSE_TLS*)	;;
    587       1.1  tron #  *-DNO_TLS*)	;;
    588       1.1  tron #           *)	CCARGS="$CCARGS -DUSE_TLS"
    589       1.1  tron #		AUXLIBS="$AUXLIBS -lssl -lcrypto"
    590       1.1  tron #		;;
    591       1.1  tron #esac
    592       1.1  tron 
    593       1.1  tron #
    594       1.1  tron # PCRE 3.x has a pcre-config utility so we don't have to guess.
    595       1.1  tron #
    596       1.1  tron case "$CCARGS" in
    597       1.1  tron *-DHAS_PCRE*)	;;
    598       1.1  tron  *-DNO_PCRE*)	;;
    599  1.1.1.10  tron 	   *)	pcre_cflags=`(pcre-config --cflags) 2>/dev/null` &&
    600       1.1  tron 		    pcre_libs=`(pcre-config --libs) 2>/dev/null` && {
    601       1.1  tron 			CCARGS="$CCARGS -DHAS_PCRE $pcre_cflags"
    602       1.1  tron 			AUXLIBS="$AUXLIBS $pcre_libs"
    603       1.1  tron 		}
    604       1.1  tron 		;;
    605       1.1  tron esac
    606       1.1  tron 
    607       1.1  tron # Defaults that can be overruled (make makefiles CC=cc OPT=-O6 DEBUG=)
    608       1.1  tron # Disable optimizations by default when compiling for Purify. Disable
    609       1.1  tron # optimizations by default with gcc 2.8, until the compiler is known to
    610       1.1  tron # be OK. Those who dare can still overrule this (make makefiles OPT=-O).
    611       1.1  tron 
    612       1.1  tron case "$CC" in
    613       1.1  tron  *purify*) : ${OPT=};;
    614       1.1  tron */gcc|gcc) case `$CC -v` in
    615       1.1  tron 	   "gcc version 2.8"*) : ${OPT=};;
    616       1.1  tron 	   esac;;
    617       1.1  tron       *CC) error "Don't use CC. That's the C++ compiler";;
    618  1.1.1.10  tron 	*) : ${OPT='-O'};;
    619       1.1  tron esac
    620       1.1  tron #
    621       1.1  tron # "gcc -W" 3.4.2 no longer reports functions that fail to return a
    622       1.1  tron # result.  Use "gcc -Wall -Wno-comment" instead. We'll figure out
    623       1.1  tron # later if the other -Wmumble options are really redundant. Having
    624       1.1  tron # een burned once by a compiler that lies about what warnings it
    625       1.1  tron # produces, not taking that chance again.
    626       1.1  tron 
    627       1.1  tron : ${CC='gcc $(WARN)'} ${OPT='-O'} ${DEBUG='-g'} ${AWK=awk} \
    628       1.1  tron ${WARN='-Wall -Wno-comment -Wformat -Wimplicit -Wmissing-prototypes \
    629       1.1  tron 	-Wparentheses -Wstrict-prototypes -Wswitch -Wuninitialized \
    630       1.1  tron 	-Wunused -Wno-missing-braces'}
    631       1.1  tron 
    632       1.1  tron export SYSTYPE AR ARFL RANLIB SYSLIBS CC OPT DEBUG AWK OPTS
    633       1.1  tron 
    634       1.1  tron # Snapshot only.
    635       1.1  tron #CCARGS="$CCARGS -DSNAPSHOT"
    636       1.1  tron 
    637       1.1  tron # Non-production: needs thorough testing, or major changes are still
    638       1.1  tron # needed before the code stabilizes.
    639       1.1  tron #CCARGS="$CCARGS -DNONPROD"
    640       1.1  tron 
    641  1.1.1.10  tron # Workaround: prepend Postfix include files before other include files.
    642  1.1.1.10  tron CCARGS="-I. -I../../include $CCARGS"
    643  1.1.1.10  tron 
    644       1.1  tron sed 's/  / /g' <<EOF
    645       1.1  tron SYSTYPE	= $SYSTYPE
    646       1.1  tron AR	= $AR
    647       1.1  tron ARFL	= $ARFL
    648       1.1  tron RANLIB	= $RANLIB
    649       1.1  tron SYSLIBS	= $AUXLIBS $SYSLIBS
    650       1.1  tron CC	= $CC $CCARGS
    651       1.1  tron OPT	= $OPT
    652       1.1  tron DEBUG	= $DEBUG
    653       1.1  tron AWK	= $AWK
    654       1.1  tron STRCASE = $STRCASE
    655       1.1  tron EXPORT	= AUXLIBS='$AUXLIBS' CCARGS='$CCARGS' OPT='$OPT' DEBUG='$DEBUG'
    656       1.1  tron WARN	= $WARN
    657       1.1  tron EOF
    658